/*******************************************************************************
 * Copyright (c) 2020 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Semantum Oy - initial API and implementation
 *******************************************************************************/
package org.simantics.db;

/**
 * @author Tuukka Lehtonen
 * @since 1.43.0
 */
public interface ResourceLocator {

    /**
     * Layer0 is an integral part of Simantics database modelling and for performance
     * reasons deserves simplest possible access to its resource class.
     * 
     * @return returns the internally cached
     *         <code>org.simantics.layer0.Layer0</code> instance
     */
    public <T> T l0();

}
